#include <SPI.h>  
#include "RF24.h"

RF24 myRadio (7, 8);

int sensorPins[4] = {A0, A2, A4, A6};
int peizoVals[4] = {0, 0, 0, 0};
int peizoPrevVals[4] = {0, 0, 0, 0};
int peizoDiffVals[4] = {0, 0, 0, 0};

struct package
{
  bool alert = 0;
  float probabilityOfFall = 0.0;
  bool hitsOrNots[4] = {0, 0, 0, 0};
};

typedef struct package Package;
Package data;

byte addresses[][6] = {"0"};

void setup() {
  // put your setup code here, to run once:
  Serial.begin(115200);
  delay(1000);
  myRadio.begin();  
  myRadio.setChannel(115); 
  myRadio.setPALevel(RF24_PA_MAX);
  myRadio.setDataRate( RF24_250KBPS ) ; 
  myRadio.openWritingPipe( addresses[0]);
  delay(1000);
}

void loop() {
  // put your main code here, to run repeatedly:
  myRadio.write(&data, sizeof(data)); 

  peizoVals[0] = analogRead(sensorPins[0]);
  peizoVals[1] = analogRead(sensorPins[1]);
  peizoVals[2] = analogRead(sensorPins[2]);
  peizoVals[3] = analogRead(sensorPins[3]);

  peizoDiffVals[0]=peizoVals[0]-peizoPrevVals[0];
  peizoDiffVals[1]=peizoVals[1]-peizoPrevVals[1];
  peizoDiffVals[2]=peizoVals[2]-peizoPrevVals[2];
  peizoDiffVals[3]=peizoVals[3]-peizoPrevVals[3];
  
  for(int i=0;i<4;i++){
    peizoPrevVals[i]=peizoVals[i];
  }

  //After we implemented the other sensor, we'll come back and add more stuff to those if statements
  if(peizoDiffVals[0]<=-10 || peizoDiffVals[0]>=10){
    data.hitsOrNots[0]=true;
  }
  else{
    data.hitsOrNots[0]=false;
  }

  if(peizoDiffVals[1]<=-10 || peizoDiffVals[1]>=10){
    data.hitsOrNots[1]=true;
  }
  else{
    data.hitsOrNots[1]=false;
  }

  if(peizoDiffVals[2]<=-10 || peizoDiffVals[2]>=10){
    data.hitsOrNots[2]=true;
  }
  else{
    data.hitsOrNots[2]=false;
  }

  if(peizoDiffVals[3]<=-10 || peizoDiffVals[3]>=10){
    data.hitsOrNots[3]=true;
  }
  else{
    data.hitsOrNots[3]=false;
  }

  Serial.print("\nPackage:");
  Serial.print(data.hitsOrNots[0]);
  Serial.print(data.hitsOrNots[1]);
  Serial.print(data.hitsOrNots[2]);
  Serial.print(data.hitsOrNots[3]);
  Serial.println("");
  delay(10);
}
